import es
import repeat
import usermsg
import cfglib


info = es.AddonInfo()
info.name = 'Join Spec'
info.version = 1.0
info.basename = 'join_spec'
info.url = 'http://addons.eventscripts.com/addons/view/join_spec'
info.author = 'Dead Man Walker'


class PlayerDelay(object):
   def __init__(self, userid):
      self.userid = int(userid)
      es.InsertServerCommand('es_changeteam %s 1' %self.userid)
      self._find_r = repeat.find("repeat_%s" %self.userid)
      if self._find_r:
         self._find_r.delete()
      self.r = repeat.create("repeat_%s" %self.userid, self.joinBackDisplay)
      self.r.start(1, JOIN_BACK_DELAY)
   def joinBackDisplay(self):
      if not JOIN_BACK_DISPLAY:
         return
      if self.time_left > 0:
         message = 'You need to wait %s seconds!' %self.time_left 
      else:
         message = 'You may join now'
      if 'chat' in JOIN_BACK_DISPLAY:
         es.tell(self.userid, '#multi', '#green[SPEC]#lightgreen ' + message)
      if 'hudhint' in JOIN_BACK_DISPLAY:
         usermsg.hudhint(self.userid, message)
      if 'keyhint' in JOIN_BACK_DISPLAY:
         usermsg.keyhint(self.userid, message)

   def getTimeLeft(self):
      return self.r['remaining']
   time_left = property(getTimeLeft)
   def __del__(self):
      self.r.delete()
      

userid_dict = {}

AVAILABEL_AREAS = [
 'chat',
 'hudhint',
 'keyhint'
]

def load():
   createCfg()
   es.addons.registerClientCommandFilter(joinFilter)

def unload():
   es.addons.unregisterClientCommandFilter(joinFilter)
   for inst in userid_dict.values():
      r = repeat.find("repeat_%s" %inst.userid)
      if r:
         r.delete()

def es_map_start(event_var):
   global userid_dict
   createCfg()
   userid_dict.clear()

def player_disconnect(event_var):
   userid = int(event_var['userid'])
   if userid in userid_dict:
      del userid_dict[userid]

def joinFilter(userid, args):
   if userid not in userid_dict:
      return True
   if args[0].lower() == 'jointeam':
      if int(args[1]) in (2,3,0,1) and userid_dict[int(userid)].time_left:
         return False
      else:
         del userid_dict[userid]
   return True
         

def player_say(event_var):
   text = event_var['text']
   userid = int(event_var['userid'])
   if text in JOIN_SPEC_COMMANDS:
      if userid in userid_dict:
         return
      if JOIN_BACK_DELAY <= 0:
         es.InsertServerCommand('es_changeteam %s 1' %userid)
      else:
         userid_dict[userid] = PlayerDelay(userid)
   
def createCfg():
   global JOIN_BACK_DELAY, JOIN_BACK_DISPLAY, JOIN_SPEC_COMMANDS
   cfg = cfglib.AddonCFG(es.ServerVar('eventscripts_gamedir') + "/cfg/" + info.basename + ".cfg")
   cfg.text("*****************************************************************")
   cfg.text("*** Join Spec Config")
   cfg.text("*****************************************************************")
   cfg.text(' ')
   CFG_JOIN_SPEC_COMMANDS = str(cfg.cvar('join_spec_commands', '!afk;!spec', 'Chat commands to join spectators. Seperate with a semicolon (;)'))
   JOIN_BACK_DELAY = int(cfg.cvar('join_back_delay', 5, 'Time in seconds the spectator has to wait untill he can join back a team'))
   CFG_JOIN_BACK_DISPLAY = str(cfg.cvar('join_back_display', 'chat;keyhint;hudhint', 'Area(s) the remaining time will be displayed in. Seperate with a semicolon (;). See the list of available areas below'))
   cfg.text(' ')
   cfg.text('Availabel display areas:')
   for item in AVAILABEL_AREAS:
      cfg.text(' -' + item)
   cfg.text(' ')
   cfg.write()
   cfg.execute()

   if CFG_JOIN_BACK_DISPLAY.strip():
      JOIN_BACK_DISPLAY = CFG_JOIN_BACK_DISPLAY.strip().split(';')
      for item in JOIN_BACK_DISPLAY:
         if not item:
            JOIN_BACK_DISPLAY.remove(item)
            continue
         if item not in AVAILABEL_AREAS:
            JOIN_BACK_DISPLAY.remove(item)
   else:
      JOIN_BACK_DISPLAY = None
   JOIN_SPEC_COMMANDS = CFG_JOIN_SPEC_COMMANDS.strip().split(';')



